// These programs demonstrate how an Arduino sketch can read input from an old 80's style 
// D-Sub equipped digital joystick and steer a Processing game on a computer by transmitting
// data across the serial line
// Author: Thomas Laubach

// The programs were inspired by the chapter on "Monski Pong"
// from the book "Making Things Talk", 2nd ed., by Tom Igoe, O'Reilly

// Joystick
int joyUP = 11; //5;
int joyDOWN = 12; //8;
int joyLEFT = 13; //6;
int joyRIGHT = 14; //7;
int joyFIRE = 15;

// Digital signals to send for each joystick/button movement
int serialUP = 0;
int serialDOWN = 0;
int serialLEFT = 0;
int serialRIGHT = 0;
int serialUPRIGHT = 0;
int serialUPLEFT = 0;
int serialDOWNRIGHT = 0;
int serialDOWNLEFT = 0;
int serialFIRE = 0;

byte t;

void setup()
{
  // Initialize serial connection
  Serial.begin(9600);
  Serial.println("Hello World!");
  // Initialize random number generator
  randomSeed(analogRead(40));

  // Initialize joysticks and  buttons
  pinMode(joyLEFT, INPUT); // DOWN
  pinMode(joyRIGHT, INPUT); // UP
  pinMode(joyUP, INPUT); // LEFT
  pinMode(joyDOWN, INPUT); // RIGHT
  pinMode(joyFIRE, INPUT); // FIRE

  // Activate internal pull-up resistors
  digitalWrite(joyLEFT, HIGH);
  digitalWrite(joyRIGHT, HIGH);
  digitalWrite(joyUP, HIGH);
  digitalWrite(joyDOWN, HIGH);
  digitalWrite(joyFIRE, HIGH);
}


void loop()
{ 
  if (t == 255) { t = 0; } else { t++; }

  if (t % 10 == 0)
  {
    if (digitalRead(joyFIRE) == LOW)
    {
      serialFIRE = 1; 
    }
    else { serialFIRE = 0; }
    
    if  (digitalRead(joyUP) == LOW) // NORTH
    {
      serialUP = 1;
      
      if  (digitalRead(joyRIGHT) == LOW)
      {
        serialUPRIGHT = 1;
      }
      else { serialUPRIGHT = 0; }
      
      if (digitalRead(joyLEFT) == LOW)
      {
        serialUPLEFT = 1;
      }
      else { serialUPLEFT = 0; }
    }
    else { serialUP = 0; }
    
    
    if (digitalRead(joyDOWN) == LOW) // SOUTH
    {
      serialDOWN = 1;
      
      if  (digitalRead(joyRIGHT) == LOW)
      {
        serialDOWNRIGHT = 1;
      }
      else { serialDOWNRIGHT = 0; }
      
      if (digitalRead(joyLEFT) == LOW)
      {
        serialDOWNLEFT = 1;
      }
      else { serialDOWNLEFT = 0; }
    }
    else { serialDOWN = 0; }
    
    if (digitalRead(joyLEFT) == LOW) // WEST
    {
      serialLEFT = 1;
    }
    else { serialLEFT = 0; }
    
    if (digitalRead(joyRIGHT) == LOW) // EAST
    {
      serialRIGHT = 1;
    }
    else { serialRIGHT = 0; }

    // Send the data through the serial line
    if (t % 10 == 0) // Do not pollute the serial line
    {
      Serial.print(serialLEFT); Serial.print(",");
      Serial.print(serialRIGHT); Serial.print(",");
      Serial.print(serialUP); Serial.print(",");
      Serial.print(serialDOWN); Serial.print(",");
      Serial.print(serialUPLEFT); Serial.print(","),
      Serial.print(serialDOWNLEFT); Serial.print(",");
      Serial.print(serialUPRIGHT); Serial.print(",");
      Serial.print(serialDOWNRIGHT); Serial.print(",");
      Serial.println(serialFIRE);
    }
  }
}
